<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="66px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="userId" label="用户ID">
                            <el-input-number type="number" v-model="formData.userId"></el-input-number>
                </el-form-item>
                <el-form-item prop="otherId" label="其他ID">
                            <el-input-number type="number" v-model="formData.otherId"></el-input-number>
                </el-form-item>
                <el-form-item prop="identity" label="身份">
                            <el-input v-model="formData.identity"></el-input>
                </el-form-item>
                <el-form-item prop="reason" label="缘由">
                            <el-input v-model="formData.reason"></el-input>
                </el-form-item>
                <el-form-item prop="remove" label="移除">
                            <el-switch v-model="formData.remove"></el-switch>
                </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'BlackListEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('blackList/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/blackList/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/blackList/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
